from hermes_model import ModelInput, validate_entrypoint

from em1.model import EM1


def run_em1(model_input: dict):
    """
    Entry Point for RT-RAMSIS

    This method gets called by the RT-RAMSIS framework. It is responsible for
    initializing the model and running the model with the given input.
    """

    model_input = ModelInput(**model_input)

    model = EM1(model_input)

    model.fit()

    results = model.predict()

    results = model.parse_results(results)

    return results


@validate_entrypoint(induced=True)
def run_em1_validated(model_input: ModelInput):
    """
    Entry Point for RT-RAMSIS

    This method gets called by the RT-RAMSIS framework. It is responsible for
    initializing the model and running the model with the given input.
    """

    model = EM1(model_input)

    model.fit()

    results = model.predict()

    results = model.parse_results(results)

    return results
